Adds an [ULTRAKILL](https://store.steampowered.com/app/1229490/ULTRAKILL/)-like style meter to the Hud of the player.
Gain 'style' by getting kills and dealing damage, extra style is given by style events that trigger under various conditions.

# Updates:

## 1.2.4:

- Mod now uses the version of ModSettings that comes with Northstar V1.16.0 or higher
- Any older versions of this mod must now use Northstar v1.15.1 or lower

## 1.2.3:

- Lots of code improvements
- Several new style events for different weapons
- No-scope event for charge rifle, kraber, longbow, double take and railgun
- Minor bug fixes

## 1.2.2:

Update created by [in1tiate](https://github.com/in1tiate)
- Added SS and SSS style ranks
- Added penalties for self damage and suicide
- Improvements to code

## 1.2.1:

- Fixed a bug where collaterals would not register
- Mod now requires version 2.0.1 of [S2ClientKillCallback](https://northstar.thunderstore.io/package/S2Mods/ClientKillCallback/)
- Added an event for assists as well as out of bounds kills
- Added an event for longshots thanks to [Mauer](https://northstar.thunderstore.io/package/TeamMauer/) and [S2ymi](https://northstar.thunderstore.io/package/S2Mods/)

## 1.2.0:

- Added a style event for headshots
- Added ModSettings v2.0 support
- Minor tweaks to style point gain
- Minor code improvements

## 1.1.0:

- Added an event for killing non-player enemies.
- Minor code improvements
- Added events for movement, speed and Air time, courtesy of [Khalmee](https://northstar.thunderstore.io/package/Khalmee/)

### This mod requires [S2ClientKillCallback](https://northstar.thunderstore.io/package/S2Mods/ClientKillCallback/) for it to function

For feedback, issues or bug reports please directly message `TheLavaLump#9401` or ping him in `#modding-chat` in the Northstar discord server.